"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const React = require("react");
const lodash_1 = require("lodash");
const react_1 = require("react");
class Filter extends React.Component {
    constructor() {
        super(...arguments);
        this.inputRef = react_1.createRef();
    }
    componentDidUpdate(prevProps) {
        if (this.props.enabled !== prevProps.enabled && this.inputRef.current) {
            if (this.props.enabled) {
                this.inputRef.current.focus();
            }
            else {
                this.inputRef.current.value = '';
                this.props.onFilter(null);
            }
        }
    }
    render() {
        const { children, enabled, onFilter = () => {
        } } = this.props;
        const filter = lodash_1.debounce(onFilter, 100);
        const className = enabled ? 'is-visible' : 'is-hidden';
        return (React.createElement("span", { className: `Filter ${className}` },
            React.createElement("span", { className: "inner" },
                React.createElement("input", { ref: this.inputRef, onChange: e => {
                        filter(e.target.value.trim().toLowerCase());
                    }, onKeyDown: e => e.stopPropagation(), type: "text" })),
            children));
    }
}
exports.Filter = Filter;
