"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const React = require("react");
const which_type_1 = require("../../lib/which-type");
class EntryType extends React.Component {
    constructor(props) {
        super(props);
        this.toggle = this.toggle.bind(this);
        this.state = {
            open: props.open,
        };
    }
    toggle(e) {
        if (!this.props.allowOpen) {
            return;
        }
        e.stopPropagation();
        e.preventDefault();
        this.setState({ open: !this.state.open });
    }
    render() {
        // const { shallow = true } = this.props;
        const entry = this.props.value;
        const { open } = this.state;
        const [key, value] = entry;
        const Key = which_type_1.default(key);
        const Value = which_type_1.default(value);
        if (!open) {
            return (React.createElement("div", { onClick: this.toggle, className: "type entry closed" },
                React.createElement("div", { className: "object-item key-value" },
                    React.createElement("span", { className: "key" },
                        React.createElement(Key, { allowOpen: open, value: key })),
                    React.createElement("span", { className: "arb-info" }, "=> "),
                    React.createElement("span", { className: "value" },
                        React.createElement(Value, { allowOpen: open, value: value })))));
        }
        return (React.createElement("div", { onClick: this.toggle, className: "type entry" },
            React.createElement("span", null, '{'),
            React.createElement("div", { className: "group" },
                React.createElement("div", { className: "object-item key-value" },
                    React.createElement("span", { className: "key" }, "key:"),
                    React.createElement("span", { className: "value" },
                        React.createElement(Key, { allowOpen: open, value: key }))),
                React.createElement("div", { className: "object-item key-value" },
                    React.createElement("span", { className: "key" }, "value:"),
                    React.createElement("span", { className: "value" },
                        React.createElement(Value, { allowOpen: open, value: value })))),
            React.createElement("span", null, '}')));
    }
}
exports.EntryType = EntryType;
