"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const React = require("react");
const EntryType_1 = require("./EntryType");
const lodash_1 = require("lodash");
class SetType extends React.Component {
    constructor(props) {
        super(props);
        this.toggle = this.toggle.bind(this);
        this.state = {
            open: props.open,
        };
    }
    toggle(e) {
        if (!this.props.allowOpen) {
            return;
        }
        e.stopPropagation();
        e.preventDefault();
        this.setState({ open: !this.state.open });
    }
    render() {
        const { value, shallow = true } = this.props;
        const { open } = this.state;
        let { displayName } = this.props;
        if (!displayName) {
            displayName = value.constructor ? value.constructor.name : 'Object';
        }
        let length = value.size;
        if (shallow && !open) {
            return (React.createElement("div", { className: "type ArrayType closed", onClick: this.toggle },
                React.createElement("em", null, displayName),
                React.createElement("span", { className: "arb-info" },
                    "(",
                    length,
                    ")")));
        }
        let types = [];
        let i = 0;
        for (let entry of value.entries()) {
            types.push(React.createElement(EntryType_1.EntryType, { key: `setTypeKey-${i + 1}`, shallow: true, value: entry, allowOpen: open, open: open }));
            i++;
            if (!open && i === 10) {
                break;
            }
        }
        if (!open && length > 10) {
            types.push(React.createElement("span", { key: "setTypeMore-0", className: "more arb-info" }, "\u2026"));
        }
        if (!open) {
            // intersperce with commas
            types = lodash_1.flatten(lodash_1.zip(types, Array.from({ length: length - 1 }, (n, i) => (React.createElement("span", { key: `sep-${i}`, className: "sep" }, ",")))));
            // do mini output
            return (React.createElement("div", { className: "type set closed", onClick: this.toggle },
                React.createElement("em", null, displayName),
                React.createElement("span", { className: "arb-info" },
                    "(",
                    length,
                    ")"),
                React.createElement("span", null,
                    " ",
                    '{',
                    " "),
                types.map((type, i) => (React.createElement("div", { className: "key-value", key: `subtype-${i}` }, type))),
                React.createElement("span", null,
                    " ",
                    '}')));
        }
        return (React.createElement("div", { className: "type set", onClick: this.toggle },
            React.createElement("em", null, displayName),
            React.createElement("span", { className: "arb-info" },
                "(",
                length,
                ")"),
            React.createElement("span", null,
                " ",
                '{',
                " "),
            React.createElement("div", { className: "group" },
                React.createElement("span", { className: "arb-info" }, "[[Entries]]:"),
                types.map((type, i) => (React.createElement("div", { className: "key-value", key: `subtype-${i}` },
                    React.createElement("span", { className: "index" },
                        i,
                        ":"),
                    type)))),
            React.createElement("span", null,
                " ",
                '}')));
    }
}
exports.SetType = SetType;
