"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const React = require("react");
const classnames_1 = require("classnames");
class StringType extends React.Component {
    constructor(props) {
        super(props);
        this.state = {
            value: props.value,
            multiline: props.value.includes('\n'),
            expanded: !props.shallow,
        };
        this.onToggle = this.onToggle.bind(this);
    }
    onToggle(e) {
        e.preventDefault();
        e.stopPropagation();
        this.setState({
            expanded: !this.state.expanded,
        });
    }
    render() {
        const { bare = false, html = false } = this.props;
        const { multiline, expanded } = this.state;
        let { value } = this.state;
        if (multiline && !expanded) {
            value = value.replace(/\n/g, '↵');
        }
        const expand = (React.createElement("button", { onClick: this.onToggle, className: "icon expand" }, "+"));
        const child = html ? (React.createElement("span", { dangerouslySetInnerHTML: { __html: value } })) : (value);
        const className = classnames_1.default([
            'type',
            'string',
            {
                toggle: expanded,
                bareString: bare,
                quote: !bare,
            },
        ]);
        return (React.createElement("div", { ref: e => (this.string = e), className: className },
            multiline && expand,
            child));
    }
}
exports.StringType = StringType;
