"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const welcome = () => ({
    value: `Waves console 1.1. Docs can be found <a target="_blank" href="https://github.com/wavesplatform/waves-repl/blob/master/README.md">here</a>
Use <strong>help()</strong> to show commands. `,
    html: true,
});
const history = ({ app, args: [n = null] }) => __awaiter(this, void 0, void 0, function* () {
    const history = app.context.store.getState().history;
    if (n === null) {
        return history.map((item, i) => `${i}: ${item.trim()}`).join('\n');
    }
    // try to re-issue the historical command
    const command = history.find((item, i) => i === n);
    if (command) {
        app.onRun(command);
    }
    return;
});
const clear = ({ console }) => {
    console.clear();
};
const commands = {
    welcome,
    clear,
    history
};
exports.default = commands;
