"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const React = require("react");
const react_redux_1 = require("react-redux");
const store_1 = require("./core/store");
const Env_1 = require("./core/actions/Env");
const Settings_1 = require("./core/actions/Settings");
const App_1 = require("./core/containers/App");
require("./css/index.css");
require("./core/jsconsole.css");
const WavesConsoleAPI_1 = require("./WavesConsoleAPI");
class Repl extends React.Component {
    constructor(props) {
        super(props);
        if (props.theme) {
            store_1.default.dispatch(Settings_1.setTheme(props.theme));
        }
    }
    static updateEnv(env) {
        store_1.default.dispatch(Env_1.setEnv(env));
    }
    render() {
        return (React.createElement(react_redux_1.Provider, { store: store_1.default },
            React.createElement(App_1.App, { api: Repl.API })));
    }
}
Repl.API = new WavesConsoleAPI_1.WavesConsoleAPI();
exports.Repl = Repl;
